VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Improving ADC resolution by adding noise and averaging"
   ClientHeight    =   5775
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   8655
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5775
   ScaleWidth      =   8655
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox Text5 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "1"
      Top             =   1680
      Width           =   1095
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2400
      Top             =   3960
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox Text4 
      Height          =   285
      Left            =   1800
      TabIndex        =   3
      Text            =   "1000"
      Top             =   1320
      Width           =   1095
   End
   Begin VB.CommandButton Command3 
      Caption         =   "&Save image"
      Height          =   375
      Left            =   1800
      TabIndex        =   6
      Top             =   2880
      Width           =   1095
   End
   Begin VB.CommandButton Command2 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   1800
      TabIndex        =   7
      Top             =   3360
      Width           =   1095
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Draw"
      Height          =   375
      Left            =   1800
      TabIndex        =   5
      Top             =   2400
      Width           =   1095
   End
   Begin VB.PictureBox Picture1 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   5535
      Left            =   3000
      ScaleHeight     =   5505
      ScaleWidth      =   5505
      TabIndex        =   11
      Top             =   120
      Width           =   5535
   End
   Begin VB.TextBox Text3 
      Height          =   285
      Left            =   1800
      TabIndex        =   2
      Text            =   "0.1"
      Top             =   960
      Width           =   1095
   End
   Begin VB.TextBox Text2 
      Height          =   285
      Left            =   1800
      TabIndex        =   1
      Text            =   "1"
      Top             =   480
      Width           =   1095
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1800
      TabIndex        =   0
      Text            =   "8"
      Top             =   120
      Width           =   1095
   End
   Begin VB.Label Label8 
      Caption         =   "Ready/finished"
      Height          =   255
      Left            =   1800
      TabIndex        =   16
      Top             =   2040
      Width           =   1095
   End
   Begin VB.Label Label7 
      Alignment       =   1  'Right Justify
      Caption         =   "Progress:"
      Height          =   255
      Left            =   960
      TabIndex        =   15
      Top             =   2040
      Width           =   735
   End
   Begin VB.Label Label6 
      Alignment       =   1  'Right Justify
      Caption         =   "Drawwidth (px):"
      Height          =   255
      Left            =   480
      TabIndex        =   14
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label Label5 
      Alignment       =   1  'Right Justify
      Caption         =   "Number X points:"
      Height          =   255
      Left            =   360
      TabIndex        =   13
      Top             =   1320
      Width           =   1335
   End
   Begin VB.Label Label4 
      Caption         =   "Horizontal - input. Vertical - output. Both are 0-1 scale."
      Height          =   495
      Left            =   840
      TabIndex        =   12
      Top             =   5160
      Width           =   2055
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Noise magnitude (standard deviation):"
      Height          =   495
      Left            =   120
      TabIndex        =   10
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Number of averages:"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "ADC resolution (bits):"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Command1_Click()

    ' Randomise
    Randomize Timer
    
    ' Clear and set up picturebox
    Picture1.Cls
    Picture1.Scale (0, 1)-(1, 0)
    Picture1.DrawWidth = Val(Text5.Text)
    
    ' Get parameters
    adc_resolution = Val(Text1.Text)
    num_averages = Val(Text2.Text)
    noise_magnitude = Val(Text3.Text)
    num_x_points = Val(Text4.Text)
    
    ' Set up output array (so we can draw later)
    Dim output_array() As Double
    ReDim output_array(1 To num_x_points, 1 To 2) As Double
    
    ' Go through range of input voltages and fill output array accordingly
    array_index = 1
    For input_voltage = 0 To 1 Step (1 / (num_x_points - 1))
        
        ' Set X coordinate of output array
        output_array(array_index, 1) = input_voltage

        ' Now we need to decide what the output voltage is going to be.
        ' Average successive measurements
        output_voltage_sum = 0
        For n = 1 To num_averages
        
            ' Add noise to the input voltage
            input_voltage_noise = input_voltage + (noise_magnitude * Sqr(-2 * Log(Rnd())) * Cos(2 * 3.141592654 * Rnd()))
            
            ' Calculate output voltage for this measurement
            Select Case input_voltage_noise
            Case Is < 0
                ' Set to lowest output voltage
                output_voltage = 0
            Case Is >= (1 - (1 / (2 ^ adc_resolution)))
                ' Set to maximum output voltage
                output_voltage = (1 - (1 / (2 ^ adc_resolution)))
            Case Else
                ' If within linear range then work out output bits
                For bin = 0 To (1 - (1 / (2 ^ adc_resolution))) Step (1 / (2 ^ adc_resolution))
                    If input_voltage_noise >= bin And input_voltage_noise < bin + (1 / (2 ^ adc_resolution)) Then
                        output_voltage = bin
                        Exit For
                    Else
                    End If
                Next bin
            End Select
            output_voltage_sum = output_voltage_sum + output_voltage
        Next n
        output_voltage_sum = output_voltage_sum / num_averages
            
        ' Set output voltage in array
        output_array(array_index, 2) = output_voltage_sum
        
        ' Increment array_index
        array_index = array_index + 1
        
        ' Doevents
        DoEvents
        
        ' Update progress
        Label8.Caption = Str$(Int(input_voltage * 100)) + "%"
        
    Next input_voltage
    
    ' At this point, array_index holds one more than the actual number of data points generated
    
    ' Draw output
    For n = 1 To array_index - 2
        Picture1.Line (output_array(n, 1), output_array(n, 2))-(output_array(n + 1, 1), output_array(n + 1, 2)), RGB(0, 0, 0)
    Next n
    
    ' Update progress
    Label8.Caption = "Ready/finished"
    
End Sub

Private Sub Command2_Click()
    
    ' Exit program
    End
    
End Sub

Private Sub Command3_Click()
    
    ' Get filename
    CommonDialog1.DialogTitle = "Save image as..."
    CommonDialog1.Filter = "Bitmap files (*.bmp)|*.bmp"
    CommonDialog1.ShowSave
    
    ' Save picture
    If CommonDialog1.FileName <> "" Then SavePicture Picture1.Image, CommonDialog1.FileName Else
    
End Sub
